#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
#include <avr/power.h> // Required for 16 MHz Adafruit Trinket
#endif
/*
   Pin 3 zweiter Schlauch von unten | Leds: 35
   Pin 4 oberster Sclauch | Leds: 27
   Pin 5 zweiter Schlauch von oben | Leds: 31
   Pin 6 Rückenteil oberste LED | Leds: 1
   Pin 7 Rückenteil Main | Leds: 12
   Pin 8 Schulterteil | Leds: 10
   Pin 9 Herz | Leds: 71
   Pin 10 Schlauch vorne | Leds: 6
   Pin 11 unterster Schlauch | Leds: 37
*/

Adafruit_NeoPixel Herz(71, 4, NEO_GRB + NEO_KHZ800); //Anzahl Pixel | Pin //3
Adafruit_NeoPixel Schlauch_vorne(6, 3, NEO_GRB + NEO_KHZ800); //2
Adafruit_NeoPixel Rueckenteil_oberste(1, 7, NEO_GRB + NEO_KHZ800);//6
Adafruit_NeoPixel Rueckenteil(10, 6, NEO_GRB + NEO_KHZ800); //5
Adafruit_NeoPixel Schlauch_unten(37, 11, NEO_GRB + NEO_KHZ800); //1
Adafruit_NeoPixel Schlauch_zweitunterste(35, 10, NEO_GRB + NEO_KHZ800);//9
Adafruit_NeoPixel Schlauch_zweitoberste(31, 8, NEO_GRB + NEO_KHZ800);//7
Adafruit_NeoPixel Schlauch_oberste(27, 9, NEO_GRB + NEO_KHZ800);//8
Adafruit_NeoPixel Schulterteil(10, 5, NEO_GRB + NEO_KHZ800); //4

Adafruit_NeoPixel Lichter_Array[9] = {Herz, Schlauch_vorne, Rueckenteil_oberste, Rueckenteil, Schlauch_unten, Schlauch_zweitunterste, Schlauch_zweitoberste, Schlauch_oberste, Schulterteil};

#define Herz_Signal 12

int blau[3] = {0, 40, 255};
int rot[3] = {255, 20, 0};
int colors[6] = {};

int laenge;
int dif_versatz;
Adafruit_NeoPixel strip;
Adafruit_NeoPixel stripZwei;

int strip_licht_abstufung[3];
int strip_farbe[3];

int stripZwei_licht_abstufung[3];
int stripZwei_farbe[3];

int schlauch_random[4] = {};
int abstand_random[2] = {};
bool richtung_random[4] = {};

bool richtung_1;
int farben[6] = {};
int laenge_1;
Adafruit_NeoPixel strip_1;
bool richtung_2;
int laenge_2;
Adafruit_NeoPixel strip_2;
int versatz;

bool richtung_vorne;

void setup() {
  Serial.begin(9600);
  randomSeed(analogRead(A0));
  pinMode(Herz_Signal, INPUT);
  
  for (int i = 0; i < 9; i++) {
    Lichter_Array[i].begin();
    Lichter_Array[i].show();
  }

  Schlauch_vorne.setBrightness(100);
  Rueckenteil_oberste.setBrightness(100);
  Schlauch_unten.setBrightness(100);
  Schlauch_zweitunterste.setBrightness(100);
  Schlauch_zweitoberste.setBrightness(100);
  Schlauch_oberste.setBrightness(100);
  
  delay(500);
  Test();
}

void Test() {
  for (int i = 0; i < 9; i++) {
    Lichter_Array[i].setPixelColor(0, Lichter_Array[i].Color(0, 255, 0));
    Lichter_Array[i].show();
    delay(300);
    Lichter_Array[i].setPixelColor(0, Lichter_Array[i].Color(0, 0, 0));
    Lichter_Array[i].show();
  }
}

void Herz_Status() {
  int state = digitalRead(Herz_Signal);
  if (state == 1) {
    Rueckenteil_oberste.setPixelColor(0, Rueckenteil_oberste.Color(255, 145, 0));
    Rueckenteil_oberste.show();
  } else {
    Rueckenteil_oberste.setPixelColor(0, Rueckenteil_oberste.Color(blau[0], blau[1], blau[2]));
    Rueckenteil_oberste.show();
  }
}

void Blutlaufanimation () {
  Serial.println("\nAbstand Richtung Schlauch");

  for (int i = 0; i < 4; i++) {
    schlauch_random[i] = random(4);
    for (int s = 0; s < 4; s++) {
      if (schlauch_random[i] == schlauch_random[s] && i != s) {
        i--;
      }
    }
  }

  for ( int i = 0; i < 4; i++) {
    if (i < 2) {
      abstand_random[i] = random(29);
      Serial.print(abstand_random[i]);
      Serial.print(" | ");
    } else {
      Serial.print("   | ");
    }
    int rand_bool = random(4);
    if (rand_bool < 2) {
      richtung_random[i] = true;
      Serial.print("True");
    } else {
      richtung_random[i] = false;
      Serial.print("False");
    }
    Serial.print(" | ");
    Serial.println(schlauch_random[i]);
  }
  Serial.println();

  int color = random(4);
  if (color == 0) {
    Serial.println("Farbe: blau-rot");
    for (int i = 0; i < 6; i++) {
      if (i < 3) {
        colors[i] = blau[i];
      } else {
        colors[i] = rot[i - 3];
      }
    }
  } else if (color == 1) {
    Serial.println("Farbe: rot-blau");
    for (int i = 0; i < 6; i++) {
      if (i < 3) {
        colors[i] = rot[i];
      } else {
        colors[i] = blau[i - 3];
      }
    }
  } else if (color == 3) {
    Serial.println("Farbe: blau-blau");
    for (int i = 0; i < 6; i++) {
      if (i < 3) {
        colors[i] = blau[i];
      } else {
        colors[i] = blau[i - 3];
      }
    }
  } else {
    Serial.println("Farbe: rot-rot");
    for (int i = 0; i < 6; i++) {
      if (i < 3) {
        colors[i] = rot[i];
      } else {
        colors[i] = rot[i - 3];
      }
    }
  }

  //Hauptmethode
  //void Lichtlauf (bool richtung_1, int farben[6], int laenge_1, Adafruit_NeoPixel strip_1,
  //                bool richtung_2, int laenge_2, Adafruit_NeoPixel strip_2,
  //                int versatz) {

  //  Lichtlauf(richtung_random[0], colors , Lichter_Array[schlauch_random[0] + 4].numPixels(), Lichter_Array[schlauch_random[0] + 4],
  //            richtung_random[1], Lichter_Array[schlauch_random[1] + 4].numPixels(), Lichter_Array[schlauch_random[1] + 4],
  //            abstand_random[0]);
  //
  //  delay(200);
  //
  //  Lichtlauf(richtung_random[2], colors, Lichter_Array[schlauch_random[2] + 4].numPixels(), Lichter_Array[schlauch_random[2] + 4],
  //            richtung_random[3], Lichter_Array[schlauch_random[3] + 4].numPixels(), Lichter_Array[schlauch_random[3] + 4],
  //            abstand_random[1]);

  for (int s = 0; s < 2; s++) {

    richtung_1 = richtung_random[s * 2];
    for (int i = 0; i < 6; i++) {
      farben[i] = colors[i];
    }
    laenge_1 = Lichter_Array[schlauch_random[s * 2] + 4].numPixels();
    strip_1 = Lichter_Array[schlauch_random[s * 2] + 4];

    richtung_2 = richtung_random[(s * 2) + 1];
    laenge_2 = Lichter_Array[schlauch_random[(s * 2) + 1] + 4].numPixels();
    strip_2 =  Lichter_Array[schlauch_random[(s * 2) + 1] + 4];
    versatz = abstand_random[s];

    if (laenge_1 > laenge_2) {
      laenge = laenge_1;
      strip = strip_1;
      stripZwei = strip_2;

      strip_licht_abstufung[2] = farben[2] / 4;
      strip_licht_abstufung[1] = farben[1] / 4;
      strip_licht_abstufung[0] = farben[0] / 4;

      strip_farbe[0] = farben[0];
      strip_farbe[1] = farben[1];
      strip_farbe[2] = farben[2];

      stripZwei_licht_abstufung[2] = farben[5] / 4;
      stripZwei_licht_abstufung[1] = farben[4] / 4;
      stripZwei_licht_abstufung[0] = farben[3] / 4;

      stripZwei_farbe[0] = farben[3];
      stripZwei_farbe[1] = farben[4];
      stripZwei_farbe[2] = farben[5];

    } else {
      laenge = laenge_2;
      strip = strip_2;
      stripZwei = strip_1;

      strip_licht_abstufung[2] = farben[5] / 4;
      strip_licht_abstufung[1] = farben[4] / 4;
      strip_licht_abstufung[0] = farben[3] / 4;

      strip_farbe[0] = farben[3];
      strip_farbe[1] = farben[4];
      strip_farbe[2] = farben[5];

      stripZwei_licht_abstufung[2] = farben[2] / 4;
      stripZwei_licht_abstufung[1] = farben[1] / 4;
      stripZwei_licht_abstufung[0] = farben[0] / 4;

      stripZwei_farbe[0] = farben[0];
      stripZwei_farbe[1] = farben[1];
      stripZwei_farbe[2] = farben[2];
    }

    Serial.print("Anfang ...");

    if ((richtung_1 == true and richtung_2 == true) or (richtung_1 == true and richtung_2 == false)) {
      for (int i = 0; i < laenge + 5; i++) {
        if (i >= versatz) {
          stripZwei.setPixelColor(i - versatz, stripZwei.Color(stripZwei_farbe[0], stripZwei_farbe[1], stripZwei_farbe[2]));
          stripZwei.setPixelColor(i - 1 - versatz, stripZwei.Color(stripZwei_farbe[0] - stripZwei_licht_abstufung[0], stripZwei_farbe[1] - stripZwei_licht_abstufung[1], stripZwei_farbe[2] - stripZwei_licht_abstufung[2]));
          stripZwei.setPixelColor(i - 2 - versatz, stripZwei.Color(stripZwei_farbe[0] - (2 * stripZwei_licht_abstufung[0]), stripZwei_farbe[1] - (2 * stripZwei_licht_abstufung[1]), stripZwei_farbe[2] - (2 * stripZwei_licht_abstufung[2])));
          stripZwei.setPixelColor(i - 3 - versatz, stripZwei.Color(stripZwei_farbe[0] - (3 * stripZwei_licht_abstufung[0]), stripZwei_farbe[1] - (3 * stripZwei_licht_abstufung[1]), stripZwei_farbe[2] - (3 * stripZwei_licht_abstufung[2])));
          stripZwei.setPixelColor(i - 4 - versatz, stripZwei.Color(stripZwei_farbe[0] - (4 * stripZwei_licht_abstufung[0]), stripZwei_farbe[1] - (4 * stripZwei_licht_abstufung[1]), stripZwei_farbe[2] - (4 * stripZwei_licht_abstufung[2])));
          stripZwei.setPixelColor(i - 5 - versatz, stripZwei.Color(0, 0, 0));
          stripZwei.show();
        }
        strip.setPixelColor(i, strip.Color(strip_farbe[0], strip_farbe[1], strip_farbe[2]));
        strip.setPixelColor(i - 1, strip.Color(strip_farbe[0] - strip_licht_abstufung[0], strip_farbe[1] - strip_licht_abstufung[1], strip_farbe[2] - strip_licht_abstufung[2]));
        strip.setPixelColor(i - 2, strip.Color(strip_farbe[0] - (2 * strip_licht_abstufung[0]), strip_farbe[1] - (2 * strip_licht_abstufung[1]), strip_farbe[2] - (2 * strip_licht_abstufung[2])));
        strip.setPixelColor(i - 3, strip.Color(strip_farbe[0] - (3 * strip_licht_abstufung[0]), strip_farbe[1] - (3 * strip_licht_abstufung[1]), strip_farbe[2] - (3 * strip_licht_abstufung[2])));
        strip.setPixelColor(i - 4, strip.Color(strip_farbe[0] - (4 * strip_licht_abstufung[0]), strip_farbe[1] - (4 * strip_licht_abstufung[1]), strip_farbe[2] - (4 * strip_licht_abstufung[2])));
        strip.setPixelColor(i - 5, strip.Color(0, 0, 0));
        strip.show();

        delay(70);
      }

      dif_versatz = versatz - 5;
      for (int i = 0; i < versatz; i++) {
        stripZwei.setPixelColor(i + laenge - dif_versatz, stripZwei.Color(stripZwei_farbe[0], stripZwei_farbe[1], stripZwei_farbe[2]));
        stripZwei.setPixelColor(i - 1 + laenge - dif_versatz, stripZwei.Color(stripZwei_farbe[0] - stripZwei_licht_abstufung[0], stripZwei_farbe[1] - stripZwei_licht_abstufung[1], stripZwei_farbe[2] - stripZwei_licht_abstufung[2]));
        stripZwei.setPixelColor(i - 2 + laenge - dif_versatz, stripZwei.Color(stripZwei_farbe[0] - (2 * stripZwei_licht_abstufung[0]), stripZwei_farbe[1] - (2 * stripZwei_licht_abstufung[1]), stripZwei_farbe[2] - (2 * stripZwei_licht_abstufung[2])));
        stripZwei.setPixelColor(i - 3 + laenge - dif_versatz, stripZwei.Color(stripZwei_farbe[0] - (3 * stripZwei_licht_abstufung[0]), stripZwei_farbe[1] - (3 * stripZwei_licht_abstufung[1]), stripZwei_farbe[2] - (3 * stripZwei_licht_abstufung[2])));
        stripZwei.setPixelColor(i - 4 + laenge - dif_versatz, stripZwei.Color(stripZwei_farbe[0] - (4 * stripZwei_licht_abstufung[0]), stripZwei_farbe[1] - (4 * stripZwei_licht_abstufung[1]), stripZwei_farbe[2] - (4 * stripZwei_licht_abstufung[2])));
        stripZwei.setPixelColor(i - 5 + laenge - dif_versatz, stripZwei.Color(0, 0, 0));
        stripZwei.show();
        delay(70);
      }
    } else {
      for (int i = laenge; i > -6; i--) {
        if (i <= (laenge - versatz)) {
          stripZwei.setPixelColor(i + versatz, stripZwei.Color(stripZwei_farbe[0], stripZwei_farbe[1], stripZwei_farbe[2]));
          stripZwei.setPixelColor(i + 1 + versatz, stripZwei.Color(stripZwei_farbe[0] - stripZwei_licht_abstufung[0], stripZwei_farbe[1] - stripZwei_licht_abstufung[1], stripZwei_farbe[2] - stripZwei_licht_abstufung[2]));
          stripZwei.setPixelColor(i + 2 + versatz, stripZwei.Color(stripZwei_farbe[0] - (2 * stripZwei_licht_abstufung[0]), stripZwei_farbe[1] - (2 * stripZwei_licht_abstufung[1]), stripZwei_farbe[2] - (2 * stripZwei_licht_abstufung[2])));
          stripZwei.setPixelColor(i + 3 + versatz, stripZwei.Color(stripZwei_farbe[0] - (3 * stripZwei_licht_abstufung[0]), stripZwei_farbe[1] - (3 * stripZwei_licht_abstufung[1]), stripZwei_farbe[2] - (3 * stripZwei_licht_abstufung[2])));
          stripZwei.setPixelColor(i + 4 + versatz, stripZwei.Color(stripZwei_farbe[0] - (4 * stripZwei_licht_abstufung[0]), stripZwei_farbe[1] - (4 * stripZwei_licht_abstufung[1]), stripZwei_farbe[2] - (4 * stripZwei_licht_abstufung[2])));
          stripZwei.setPixelColor(i + 5 + versatz, stripZwei.Color(0, 0, 0));
          stripZwei.show();
        }
        strip.setPixelColor(i, strip.Color(strip_farbe[0], strip_farbe[1], strip_farbe[2]));
        strip.setPixelColor(i + 1, strip.Color(strip_farbe[0] - strip_licht_abstufung[0], strip_farbe[1] - strip_licht_abstufung[1], strip_farbe[2] - strip_licht_abstufung[2]));
        strip.setPixelColor(i + 2, strip.Color(strip_farbe[0] - (2 * strip_licht_abstufung[0]), strip_farbe[1] - (2 * strip_licht_abstufung[1]), strip_farbe[2] - (2 * strip_licht_abstufung[2])));
        strip.setPixelColor(i + 3, strip.Color(strip_farbe[0] - (3 * strip_licht_abstufung[0]), strip_farbe[1] - (3 * strip_licht_abstufung[1]), strip_farbe[2] - (3 * strip_licht_abstufung[2])));
        strip.setPixelColor(i + 4, strip.Color(strip_farbe[0] - (4 * strip_licht_abstufung[0]), strip_farbe[1] - (4 * strip_licht_abstufung[1]), strip_farbe[2] - (4 * strip_licht_abstufung[2])));
        strip.setPixelColor(i + 5, strip.Color(0, 0, 0));
        strip.show();

        delay(70);
      }

      for (int i = versatz - 5; i > -6; i--) {
        stripZwei.setPixelColor(i , stripZwei.Color(stripZwei_farbe[0], stripZwei_farbe[1], stripZwei_farbe[2]));
        stripZwei.setPixelColor(i + 1, stripZwei.Color(stripZwei_farbe[0] - stripZwei_licht_abstufung[0], stripZwei_farbe[1] - stripZwei_licht_abstufung[1], stripZwei_farbe[2] - stripZwei_licht_abstufung[2]));
        stripZwei.setPixelColor(i + 2, stripZwei.Color(stripZwei_farbe[0] - (2 * stripZwei_licht_abstufung[0]), stripZwei_farbe[1] - (2 * stripZwei_licht_abstufung[1]), stripZwei_farbe[2] - (2 * stripZwei_licht_abstufung[2])));
        stripZwei.setPixelColor(i + 3, stripZwei.Color(stripZwei_farbe[0] - (3 * stripZwei_licht_abstufung[0]), stripZwei_farbe[1] - (3 * stripZwei_licht_abstufung[1]), stripZwei_farbe[2] - (3 * stripZwei_licht_abstufung[2])));
        stripZwei.setPixelColor(i + 4, stripZwei.Color(stripZwei_farbe[0] - (4 * stripZwei_licht_abstufung[0]), stripZwei_farbe[1] - (4 * stripZwei_licht_abstufung[1]), stripZwei_farbe[2] - (4 * stripZwei_licht_abstufung[2])));
        stripZwei.setPixelColor(i + 5, stripZwei.Color(0, 0, 0));
        stripZwei.show();
        delay(70);
      }
    }
    strip.clear();
    strip.show();

    stripZwei.clear();
    stripZwei.show();
    Serial.println("Ende");
    delay(20);
  }

  for (int i = 0; i < 4; i++) { //arrays wieder leeren
    schlauch_random[i] = -1;
    if (i < 2) {
      abstand_random[i] = 0;
    }
    richtung_random[i] = false;
  }
}

void Animation_vorne() {
  int richtung = random(4);

  if (richtung < 2) {
    richtung = true;
  } else {
    richtung = false;
  }
  if (richtung) {
    for (int i = 0; i < Schlauch_vorne.numPixels() + 5; i++) {
      Schlauch_vorne.setPixelColor(i , Schlauch_vorne.Color(strip_farbe[0], strip_farbe[1], strip_farbe[2]));
      Schlauch_vorne.setPixelColor(i - 1, Schlauch_vorne.Color(strip_farbe[0] - strip_licht_abstufung[0], strip_farbe[1] - strip_licht_abstufung[1], strip_farbe[2] - strip_licht_abstufung[2]));
      Schlauch_vorne.setPixelColor(i - 2, Schlauch_vorne.Color(strip_farbe[0] - (2 * strip_licht_abstufung[0]), strip_farbe[1] - (2 * strip_licht_abstufung[1]), strip_farbe[2] - (2 * strip_licht_abstufung[2])));
      Schlauch_vorne.setPixelColor(i - 3, Schlauch_vorne.Color(strip_farbe[0] - (3 * strip_licht_abstufung[0]), strip_farbe[1] - (3 * strip_licht_abstufung[1]), strip_farbe[2] - (3 * strip_licht_abstufung[2])));
      Schlauch_vorne.setPixelColor(i - 4, Schlauch_vorne.Color(strip_farbe[0] - (4 * strip_licht_abstufung[0]), strip_farbe[1] - (4 * strip_licht_abstufung[1]), strip_farbe[2] - (4 * strip_licht_abstufung[2])));
      Schlauch_vorne.setPixelColor(i - 5, Schlauch_vorne.Color(0, 0, 0));
      Schlauch_vorne.show();
      delay(70);
    }
  } else {
    for (int i = Schlauch_vorne.numPixels(); i > -6; i--) {
      Schlauch_vorne.setPixelColor(i , Schlauch_vorne.Color(stripZwei_farbe[0], stripZwei_farbe[1], stripZwei_farbe[2]));
      Schlauch_vorne.setPixelColor(i + 1, Schlauch_vorne.Color(stripZwei_farbe[0] - stripZwei_licht_abstufung[0], stripZwei_farbe[1] - stripZwei_licht_abstufung[1], stripZwei_farbe[2] - stripZwei_licht_abstufung[2]));
      Schlauch_vorne.setPixelColor(i + 2, Schlauch_vorne.Color(stripZwei_farbe[0] - (2 * stripZwei_licht_abstufung[0]), stripZwei_farbe[1] - (2 * stripZwei_licht_abstufung[1]), stripZwei_farbe[2] - (2 * stripZwei_licht_abstufung[2])));
      Schlauch_vorne.setPixelColor(i + 3, Schlauch_vorne.Color(stripZwei_farbe[0] - (3 * stripZwei_licht_abstufung[0]), stripZwei_farbe[1] - (3 * stripZwei_licht_abstufung[1]), stripZwei_farbe[2] - (3 * stripZwei_licht_abstufung[2])));
      Schlauch_vorne.setPixelColor(i + 4, Schlauch_vorne.Color(stripZwei_farbe[0] - (4 * stripZwei_licht_abstufung[0]), stripZwei_farbe[1] - (4 * stripZwei_licht_abstufung[1]), stripZwei_farbe[2] - (4 * stripZwei_licht_abstufung[2])));
      Schlauch_vorne.setPixelColor(i + 5, Schlauch_vorne.Color(0, 0, 0));
      Schlauch_vorne.show();

      delay(70);
    }
  }
}

void loop() {
  Animation_vorne();
  Herz_Status();
  int randi = random(2) + 1;
  for (int i = 0; i < randi; i++) {
    Blutlaufanimation();
  }  
}
